<template>
  <div class="posicion">
    <icono-de-estado :tipo="posicion.estado" />
    <div class="body">
      <div class="head">
        <h4>{{ posicion.pirata.nick }}</h4>
        <span class="fecha">{{ fechaRelativa(posicion.created_at) }}</span>
      </div>
      <p>{{ posicion.comentario }}</p>
      <a
        href=""
        v-if="posicionesAnteriores.length > 0"
        @click.prevent="mostrarAnteriores = !mostrarAnteriores"
      >
        <template v-if="mostrarAnteriores">
          ocultar
        </template>
        <template v-else>
          mostrar
        </template>
        posiciones anteriores
      </a>
      <div class="posiciones-anteriores" v-if="mostrarAnteriores">
        <div class="posicion-anterior" v-for="posicion in posicionesAnteriores">
          <icono-de-estado :tipo="posicion.estado" />
          <p>
            {{ posicion.comentario }}
            <span class="fecha">{{ fechaRelativa(posicion.created_at) }}</span>
          </p>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { formatRelative } from 'date-fns'
import { es } from 'date-fns/locale'

import IconoDeEstado from '@/components/IconoDeEstado'

export default {
  name: 'Posicion',
  props: ['posicion', 'posiciones'],
  components: { IconoDeEstado },
  data() {
    return {
      mostrarAnteriores: false,
    }
  },
  methods: {
    fechaRelativa(date) {
      return formatRelative(new Date(date), Date.now(), {
        locale: es,
      })
    },
  },
  computed: {
    posicionesDeEstaPirata() {
      return this.posiciones.filter(
        posicion => posicion.pirata.id === this.posicion.pirata.id,
      )
    },
    posicionesAnteriores() {
      return this.posicionesDeEstaPirata.filter(
        posicion => posicion.id !== this.posicion.id,
      )
    },
    indexDeEstaPirata() {
      return this.posicionesDeEstaPirata.findIndex(
        posicion => posicion.id === this.posicion.id,
      )
    },
  },
}
</script>

<style lang="sass" scoped>
.posicion
  display: flex
  padding: 15px
  border-bottom: 2px solid #ccc
  &:first-child
    border-top: 2px solid #ccc
  text-align: left
  .icono-de-estado
    padding: 8px
    margin: 0
    margin-right: 0.5em
  .body
    flex: 1
    word-break: break-word
  h4, p
    margin: 0
  p
    width: 100%
  .posiciones-anteriores
    border-left: 4px solid var(--darkgray)
    padding-left: 10px
    margin-left: 10px
    .posicion-anterior
      display: flex
      border-top: 1px solid var(--darkgray)
      padding: 5px 0
  .head
    width: 100%
    h4
      display: inline-block
  .fecha
    float: right
    color: var(--darkgray)
</style>
